unit UVrchol;    { zakladni unit , obsahuje reprezentaci vrcholu grafu }



interface

     const MaxN = 15 ; { constanta maximalniho poctu vrcholu }



type asousedi = array [1..MaxN] of real ;{ typ pole sousedu }

type pvrchol = ^tvrchol; { reprezentace vrcholu objectem }
     tvrchol = object
     constructor vytvor ;
     procedure zbarva (b:byte );
     procedure zx ( a:integer);
     procedure zy ( a:integer);
     procedure zjmeno( s:string);
     procedure zkomp ( b:byte);
     procedure zhodn ( a:real);
     procedure zsouseda ( a:byte; b:real);
     function vbarva:byte;
     function vkomp:byte;
     function vjmeno:string;
     function vx:integer;
     function vy:integer;
     function vhodn:real;
     function vsouseda( a:byte):real;
     private
        x,y : integer;     { souradnice vrcholu }
        jmeno : string;    { komentar k vrcholu }
        hodn : real;        { hodnota vrcholu }
        barva , komp : byte ;  { dulezite udaje - vyjadrene cislem }
        sous :asousedi;     { hrany smerujici do ostatnich vrcholu }
        end;


implementation

constructor tvrchol.vytvor ;  { vytvoreni noveho vrcholu }
var i:byte;
begin
 zbarva (0);     { nulovani hodnot pomoci jinych podprogramu objectu }
 zjmeno('');
 zkomp(0);
 zhodn(0);
 zx( random (300));
 zy( random (160));
 for i:=1 to MaxN do   sous[i]:=0;
end;

{ zmeny jednotlivych privatnich promenych objectu }

procedure tvrchol.zbarva (b:byte );
begin
     barva:=b;
end;

procedure tvrchol.zx ( a:integer);
     begin
     x:=a;
     end;


procedure tvrchol.zy ( a:integer);
     begin
     y:=a;
     end;

procedure tvrchol.zjmeno( s:string);
     begin
     jmeno:=s;
     end;

procedure tvrchol.zkomp ( b:byte);
     begin
     komp:=b;
     end;

procedure tvrchol.zhodn ( a:real);
     begin
     hodn:=a;
     end;

procedure tvrchol.zsouseda ( a:byte; b:real);
     begin
     sous[a]:=b;
     end;

     { zjisteni hodnot jednotlivych privatnich promenych }
     
     function tvrchol.vbarva:byte;
     begin
     vbarva := barva;
     end;
     
     function tvrchol.vkomp:byte;
     begin
     vkomp :=komp;
     end;
     
     function tvrchol.vjmeno:string;
     begin
     vjmeno := jmeno;
     end;
     
     function tvrchol.vx:integer;
     begin
     vx := x;
     end;
     
     function tvrchol.vy:integer;
     begin
     vy := y;
     end;
     
     function tvrchol.vhodn:real;
     begin
     vhodn := hodn;
     end;
     
     function tvrchol.vsouseda( a:byte):real;
     begin
     vsouseda:=sous[a];
     end;
     
end.

