unit FrmDijkstra;   { Formular , ktery nacte vychozi a pripadne cilovy vrchol a najde nekratsi cesty }

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons
  ,  umetody;

type

  { TForm5 }

  TForm5 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Form5Show(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form5: TForm5; 
  pokr:boolean;

implementation

uses ugraf,uvykresli,hlavni,ukontrola;

type abylo = array [ 1..MaxN ] of boolean;
type areal = array [ 1..MaxN ] of real;

{ TForm5 }

var n,zk:byte;

procedure kontrul(s:string); { kontrolije koreknost vstupniho cisla }

begin
   zk:=zkontrul(s,'b');
   if zk > 1 then Showmessage( ' zadal jsi necislo ');
end;


procedure dijkstra(var m:char);      { Procedura provede Dijkstruv algoritmus }
var i,n,s,c,v:byte;
    k,e:real;
    by:abylo;
    vrch: areal;
    kon:boolean;
const MaxR = 124865533.9921875;      { Konstanta ktera je predpokladana jako nekonecno }

begin
n:=graf.vvrcholu;
tkgr.kresligraf(clBlack,clSilver);

s:=F5Str;
c:=F5Fin;

{showmessage('padam 4'); }
for i:= 1 to n do
begin
by[i]:= False;
vrch[i]:=MaxR;
end;
{showmessage('padam 5');}
kon:=True;
vrch[s]:=graf.gvho(s);
tk.vrchol(graf.gvx(s),graf.gvy(s),clBlue);
if ( IForm5 = 'n' ) then tk.vrchol(graf.gvx(c),graf.gvy(c),clBlue);
v:=s;
{showmessage('padam 6');  }
{for i:=1 to n do
if by[i] then showmessage ('koncim '+inttostr(i))
         else showmessage ('pokracuji '+inttostr(i));
}
for i:=1 to n do
begin
{if not by[i] then
begin}
kon := ( kon and (vrch[i] =  MaxR ));
{if kon then showmessage ('koncim '+inttostr(i))
       else showmessage ('pokracuji '+inttostr(i));}
{end;  }
by[s]:=True;
end;
{showmessage('padam 7');}
{if vrch[3] <> MaxR then showmessage(' vtch3 je prozatim spatny' ); }
while not kon do
begin
k:=MaxR;
for i:=1 to n do
 if (not by[i]) and ( k > vrch[i] ) then
    begin
{      showmessage ('menim'+inttostr(v) + ' za ' + inttostr(i)+' s hodnotou ' +floattostr(vrch[i]));}
      k:=vrch[i];
      v:=i;
    end;
{showmessage(inttostr(v)+' q ' +floattostr(k));}
by[v]:=True;
for i:=1 to n do
if (i<>v) then
begin
   e := graf.gvsou(i,v);
   if e > 0 then
       if ( ( e + vrch[v] + graf.gvho(i)) < vrch[i] ) then
               begin
               vrch[i] := ( e + vrch[v] + graf.gvho(i)) ;
               end;
   if e < 0 then
        begin
        showmessage ( ' nasel jsem zapornou hranu - tedy nejmensi zaporny cyklus a proto koncim ');
        tk.hrana ( graf.gvx(v),graf.gvy(v),graf.gvx(i),graf.gvy(i),clBlue);
        kon:=True;
        end;
end;
{showmessage('barvim ');}
for i:=1 to n do
begin
    if (( vrch[i] + graf.gvsou(i,v) +graf.gvho(v) ) = vrch[v] )and ( graf.gvsou(i,v)>0) then
             begin
             tk.hrana(graf.gvx(i),graf.gvy(i),graf.gvx(v),graf.gvy(v),clMaroon);
if IForm5 <>'n' then  showmessage(' Mam nejkratsi cestu k vrcholu ' +inttostr(i)+' celkove delky '+floattostr(vrch[i]));
             end;
end;
{showmessage('po barvim '); }
kon:=True;
for i:=1 to n do
begin
if ( not by[i] ) then
begin
{showmessage(inttostr(i) + ' nebylo jeste pouzito ');}
{if vrch[3] <> MaxR then showmessage( ' vrch byl nekdy zmenen ');  }
kon := kon and ( vrch[i] =  MaxR );
end;
{if kon then showmessage ('koncim')
       else showmessage ('pokracuji');}
end;
{if kon then showmessage ('koncim')
       else showmessage ('pokracuji');}


end;


if (IForm5 = 'n') then
  begin
  v:=c;
  if (vrch[c] = MaxR ) then showmessage(' Trasa v grafu z vrcholu '+inttostr(s)+' do vrcholu '+inttostr(c)+' neexistuje ')
   else
   begin
   Form1.Memo1.Text:= ' Celkova delka trasy  z vrcholu '+inttostr(s)+' do vrcholu '+inttostr(c)+' je '+floattostr(vrch[c]);
  repeat
    for i:=1 to n do
    if (( vrch[i] + graf.gvsou(i,v) ) = vrch[v] )and ( graf.gvsou(i,v)>0) then
       begin
       tk.hrana(graf.gvx(i),graf.gvy(i),graf.gvx(v),graf.gvy(v),clBlue);
       v:=i;
       break;
       end;
  until ( v = s ) ;
  end;
end;
end;

procedure TForm5.BitBtn2Click(Sender: TObject);      { Ukonceni formulare - bez hledani cesty }
begin
   Pokr:=True;
   Close;
end;

procedure TForm5.Form5Show(Sender: TObject);    { Folmular se ukaze ve spravne podobe podle pozadovanych ukolu }
begin
 { Edit4.Text:=inttostr(F5str);}
  if (Iform5 = 'n') then
  begin
   Edit3.Visible:=True;
   Edit5.Visible:=True;
{   Edit5.Text:= inttostr(F5fin);}
  end
  else
  begin
   Edit3.Visible:=False;
   Edit5.Visible:=False;
   Edit5.Text:='0';
  end;

end;

procedure TForm5.BitBtn1Click(Sender: TObject);   { Nacitani ukonceno ,
v procedure se provede zjisteni koreknosti vstupnich dat a provede se pozadovane operace }

var j:byte;
begin
  n:=graf.vvrcholu;
  j:=0;
  kontrul(Edit4.Text);
  j:=j + zk ;
  kontrul(Edit5.Text);
  if ( Iform5 = 'n') then j := j + zk
     else    j := j + ( zk div 2 );
  if j = 0 then
  begin
  F5str:=strtoint(Edit4.Text);
  F5fin:=strtoint(Edit5.Text);
    if ( F5str > 0 ) and ( F5str <= n ) then
    if ((( F5fin > 0 ) and ( F5fin <= n ) and ( Edit5.Visible )) or (not Edit5.Visible)) then
     begin
     pokr:=True;
     Close;
     Dijkstra(Iform5);
     end
     else
        showmessage(' Zadal jsi nejaky vrchol ktery neni v grafu ' )
     else
        showmessage(' Zadal jsi nejaky vrchol ktery neni v grafu ' );
  end
  else if j = 1 then showmessage ( ' nezadal jsi cislo okrajoveho vrcholu cesty ')
       else showmessage( ' mas nekde necislo ');
       
end;





initialization
  {$I frmdijkstra.lrs}

end.

