unit UGraf;   { Unit ktery reprezentuje object grafu }

interface



uses UVrchol;

type
  tgrafsloz = array [1..MaxN] of pvrchol;{ Vrcholy grafu }
  type    { zakladni udaje o grafu }
    tgrafudaje = object
     procedure zhrany ( a:word);     {e}
     procedure zkostry ( a:longint); {t}
     procedure ztazky ( a:longint);  {r}
     procedure zkomp ( a:byte);      {k}
     procedure zvrchol ( a:byte);    {n}
     procedure zbarv ( a:byte);      {c}
     procedure zksouv ( a:byte);     {ks}
     function vbarv:byte;            {b}
     function vkomp:byte;            {k}
     function vvrcholu:byte;         {n}
     function vksouv:byte;           {ks}
     function vhran:word;            {e}
     function vkostr:word;           {t}
     function vtazky:word;           {r}


     private
     n , k , c , ks : byte;
     e : word;
     t , r :longint;
     end;
     { privatni promene tgrafudaje :
     n  - # vrcholu
     k  - # komponent
     c  - barevnost
     ks - k souvislost
     e  - # hran
     t  - # koster
     r  - # jednotazek
     }

     type tgraf = object(tgrafudaje)
      { i - poradi vrcholu }
      constructor grcreate( b : byte );   {constructor grafu }
      { zmena jednotlivych hodnot grafu }
      procedure gzb (i:byte; b:byte );
      procedure gzx (i:byte; a:integer);
      procedure gzy (i:byte; a:integer);
      procedure gzjm(i:byte; s:string);
      procedure gzkomp (i:byte; b:byte);
      procedure gzho ( i:byte;a:real);
      procedure gzsou (i:byte; a:byte; b:real);
      { navraceni hodnot z privatnich promenych }
      function gvb(i:byte) :byte;
      function gvkomp(i:byte):byte;
      function gvjm(i:byte):string;
      function gvx(i:byte):integer;
      function gvy(i:byte):integer;
      function gvho(i:byte):real;
      function gvsou(a,i:byte):real;
      destructor grdis;          { destructor grafu }
      private
       gr : tgrafsloz  ; { privatni promena pole pointru na vrcholy
                          ze kterych je slozen graf }
       end;

var graf : tgraf;
implementation
 constructor tgraf.grcreate( b : byte );
    var i:byte;
        begin
          inherited zvrchol(b);
          for i:= 1 to b do
             gr[i]:= New(PVrchol,Vytvor );
          for i:= b+1 to MaxN do
            gr[i]:=NIL;
           inherited zvrchol(b);
       end;

   destructor tgraf.grdis;
      var i,j :byte;
      begin
         i:= inherited vvrcholu;
         for j:=1 to i do
           begin
           dispose(gr[j]);
           gr[j]:=nil;
           end;
           inherited zhrany ( 0 );
           inherited zkostry ( 0 );
           inherited ztazky ( 0 );
           inherited zkomp ( 0 );
           inherited zvrchol ( 0 );
           inherited zbarv ( 0 );
           inherited zksouv ( 0 );
     end;

    procedure tgraf.gzb (i:byte; b:byte );
          begin
            gr[i]^.zbarva(b);
          end;

    procedure tgraf.gzx ( i:byte; a:integer);
       begin
         gr[i]^.zx(a);
       end;


   procedure tgraf.gzy (i:byte; a:integer);
       begin
        gr[i]^.zy(a);
       end;


   procedure tgraf.gzjm(i:byte; s:string);
       begin
        gr[i]^.zjmeno(s);
       end;

    procedure tgraf.gzkomp (i:byte; b:byte);
       begin
        gr[i]^.zkomp(b);
       end;

     procedure tgraf.gzho (i:byte; a:real);
       begin
        gr[i]^.zhodn(a);
       end;

     procedure tgraf.gzsou (i:byte; a:byte; b:real);
       begin
        gr[i]^.zsouseda(a,b);
       end;

      function tgraf.gvb(i:byte):byte;
       begin
          gvb:=gr[i]^.vbarva;
       end;

      function tgraf.gvkomp(i:byte):byte;
       begin
          gvkomp:=gr[i]^.vkomp;
       end;

      function tgraf.gvjm(i:byte):string;
       begin
          gvjm:=gr[i]^.vjmeno;
       end;
      function tgraf.gvx(i:byte):integer;
       begin
          gvx:=gr[i]^.vx;
       end;
      function tgraf.gvy(i:byte):integer;
       begin
         gvy:=gr[i]^.vy;
        end;

       function tgraf.gvho(i:byte):real;
        begin
          gvho:=gr[i]^.vhodn;
        end;
      function tgraf.gvsou(a,i:byte):real;
       begin
         gvsou:=gr[i]^.vsouseda(a);
       end;



     procedure tgrafudaje.zhrany ( a:word );
        begin
          e := a;
        end;

     procedure tgrafudaje.zkostry ( a:longint);
      begin
        t := a;
      end;


      
     procedure tgrafudaje.ztazky ( a:longint );
      begin
        r := a;
      end;

     procedure tgrafudaje.zkomp ( a:byte );
      begin
        k := a;
      end;
     
     procedure tgrafudaje.zvrchol ( a:byte );
      begin
        n := a;
      end;

     procedure tgrafudaje.zbarv ( a:byte );
      begin
        c := a;
      end;

     procedure tgrafudaje.zksouv ( a:byte );
      begin
        ks := a;
      end;

     function tgrafudaje.vbarv:byte;
      begin
        vbarv := c;
      end;

     function tgrafudaje.vkomp:byte;
      begin
        vkomp := k;
      end;

     function tgrafudaje.vvrcholu:byte;
      begin
        vvrcholu := n;
      end;

     function tgrafudaje.vksouv:byte;
      begin
        vksouv := ks;
      end;

     function tgrafudaje.vhran:word;
      begin
        vhran :=e;
      end;

     function tgrafudaje.vkostr:word;
      begin
        vkostr := t;
      end;

     function tgrafudaje.vtazky:word;
      begin
        vtazky := r;
      end;


end.

